<?php
namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Teknisa\FIN\Controllers\TeknisaCrud;
use Financeiro\Entities\Movbancario;
use Financeiro\Entities\Movcredbanc;
use Financeiro\Entities\Movfluxo;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\FIN\Modules\MovimentacaoBancaria\Services\LancamentoCreditoService;
use Geral\Util\TratamentoDeMensagens;
use Teknisa\Libs\Util\DateUtil;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Message;

class LancamentoCreditoController extends TeknisaCrud
{
    const STATUS_CONCILIACAO = 0;
    const IDMOVFLUXO = 'R';
    protected $environment;
    protected $entityManager;
    protected $dataSourceName = 'lancamento_de_credito';

    public function __construct($crudService, ParameterBag $parameterBag, $environment, LancamentoCreditoService $service, EntityManager $entityManager) {
        $this->environment = $environment;
        $this->service = $service;
        $this->entityManager = $entityManager;
        parent::__construct($crudService, $parameterBag);
    }


    public function saveLancamentoCredito(DTO\Request $request, DTO\Response $response) {
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try {
            $rows = $request->getRow();
            $this->service->insereLancamento($rows, $response);
            
            $response->addDataSet(new DataSet("lancamento", ['success' => 'S']));
            $this->entityManager->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
    
    public function removeLancamentoCredito(DTO\Request $request, DTO\Response $response) {
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try {
            $rows = $request->getRow();
            $this->service->removeLancamento($rows);
            
            $response->addDataSet(new DataSet("lancamento", ['success' => 'S']));
            $this->entityManager->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
}